//
//  main.m
//  runObjC v1.0
//
//  Created by Charles Nichols on 8/25/12.
//  Copyright (c) 2012 Dark Artistry. All rights reserved.
//

#import <Foundation/Foundation.h>

int main(int argc, const char * argv[])
{

    @autoreleasepool {
        if (argc>1){
            //Compile
            NSFileManager *fileManager = [NSFileManager defaultManager];
            NSString *input = [[NSString alloc] initWithUTF8String: argv[1]];
            NSString *output = [input stringByDeletingPathExtension];
            NSString *routput = [input stringByDeletingPathExtension];
            
            NSLog( @"Exec: gcc %@ -o %@ -framework Foundation", input, output);
            NSString *command = @"";
            
            if ([fileManager fileExistsAtPath:@"/usr/bin/g++"])
            {
                command = [NSString stringWithFormat: @"/usr/bin/g++"];
            }
            else if ([fileManager fileExistsAtPath:@"/Developer/usr/bin/g++"])
            {
                command = [NSString stringWithFormat: @"/Developer/usr/bin/g++"];
            }
            else
            {
                command = [NSString stringWithFormat: @"/Developer/usr/bin/gcc"];
            }
            
            NSTask *task = [NSTask new];
            [task setLaunchPath: command];
            
            NSArray *arguments;
            arguments = [NSArray arrayWithObjects: input, @"-o", output,
                         @"-ObjC", @"-framework", @"Foundation", nil];
            [task setArguments: arguments];
            
            NSPipe *pipe = [NSPipe pipe];
            [task setStandardOutput:pipe];
            
            [task launch];
            
            NSData *data = [[pipe fileHandleForReading] readDataToEndOfFile];
            
            [task waitUntilExit];
            
            NSString *string = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
            NSLog (@"%@", string);
            
            NSLog( @"Exec: %@", output);
            
            //RUN OUTPUT
            NSTask *rtask = [NSTask new];
            [rtask setLaunchPath: routput];
            
            NSArray *rarguments;
            rarguments = [NSArray arrayWithObjects: nil];
            [rtask setArguments: rarguments];
            
            NSPipe *rpipe = [NSPipe pipe];
            [rtask setStandardOutput:rpipe];
            
            [rtask launch];
            
            NSData *rdata = [[rpipe fileHandleForReading] readDataToEndOfFile];
            
            [rtask waitUntilExit];
            
            NSString *rstring = [[NSString alloc] initWithData:rdata encoding:NSUTF8StringEncoding];
            NSLog (@"%@", rstring);
        }
    }
    return 0;
}
